package io.gisbi.application.system.domain;

import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Getter;
import lombok.Setter;

import java.time.LocalDateTime;

@Getter
@Setter
@TableName("app_menu")
public class Menu {
    private static final long serialVersionUID = 1L;

    /**
     * ID
     */
    private String id;
    /**
     * 应用ID 关联应用系统
     */
    private String appId;
    /**
     * 菜单类型  01-目录 02-菜单
     */
    private String type;
    /**
     * 菜单编号
     */
    private String code;
    /**
     * 同级序号
     */
    private Integer orderno;
    /**
     * 菜单名称
     */
    private String name;
    /**
     * 菜单图标 base64存储
     */
    private String icon;
    /**
     * 是否外链 0-非外部  1-是外链
     */
    private String islink;
    /**
     * 菜单URL 内部资源页面URL访问地址
     */
    private String url;
    /**
     * 模块ID 菜单关联的模块ID
     */
    private String moduleId;
    /**
     * 父级菜单ID 顶级为0
     */
    private String parentid;
    /**
     * 是否显示 0-不显示 1-显示
     */
    private String isdisplay;
    /**
     * 最近修改者
     */
    private String lastmodifier;
    /**
     * 最近修改日期
     */
    private LocalDateTime lastmodifydate;
    /**
     * 备用1
     */
    private String custom1;

    /**
     * 备用2
     */
    private String custom2;

    /**
     * 备用3
     */
    private String custom3;
}
